//
// AHSingles.h
//
// $Revision: 1.6 $ $Date: 2007/10/19 18:12:52 $
//
// Copyright (C) 2007 Robert J. McDonald.  All rights reserved.
// http://www.dancingkayak.com/codesamples/anagrams/
//
// Uses individually created DictionaryEntry objects
// for each word list entry.
// This is pretty slow as a result.
//

#ifndef AHSINGLES_H
#define AHSINGLES_H

#include "DictionaryEntry.h"
#include "AnagramHunter.h"

class AHSingles : public AnagramHunter
{
private:

	DictionaryEntry**	m_entries;
	int			m_entryCount;
	int			m_entriesLength;

	int			m_currentIndex;
	DictionaryEntry		m_dictEntry;

public:

	AHSingles();

	virtual ~AHSingles();

	// Install a list of words within which to search for anagrams
	unsigned int setDict(const char * dictPath);

	// Specify the word for which anagrams will be searched
	void setCandidate(const char * candidate);

	// Find first/next anagram of the candidate
	const char * getAnagram(void);

private:
	// Prevent compiler from auto-building unneeded copy constructor and assignment operator
	AHSingles& operator=(AHSingles& ahsingles)
	{
		return ahsingles;
	}

	AHSingles(AHSingles& ahsingles)
	{
	}
};

#endif // AHSINGLES_H

