//
// AnagramHunter.h
//
// $Revision: 1.5 $ $Date: 2007/10/19 18:12:52 $
//
// Copyright (C) 2007 Robert J. McDonald.  All rights reserved.
// http://www.dancingkayak.com/codesamples/anagrams/
//
// Abstract base class for the various strategies of hunting for anagrams.
//

#ifndef ANAGRAM_HUNTER_H
#define ANAGRAM_HUNTER_H

#include <string>

class AnagramHunter
{
protected:
	std::string		m_errorMessage;
	unsigned int		m_anagramCount;

public:

	AnagramHunter(void) : m_anagramCount(0)
	{
	}

	virtual ~AnagramHunter()
	{
	}

	// Install a list of words within which to search for anagrams
	virtual unsigned int setDict(const char * dictPath) = 0;

	// Specify the word for which anagrams will be searched
	virtual void setCandidate(const char * candidate) = 0;

	// Find first/next anagram of the candidate
	virtual const char * getAnagram(void) = 0;

	const unsigned int anagramCount(void) const
	{
		return m_anagramCount;
	}

	const char * errorMessage(void) const
	{
		return m_errorMessage.c_str();
	}
};

#endif // ANAGRAM_HUNTER_H

